package basis;

import java.util.BitSet;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;

import util.Constraint;
import util.Item;
import util.UtiltyFunction;
import util.score.ExposureCounter;

public abstract class BaseTestGenerator implements ITestGenerator {

    public EnumerationType.MethodName method;
    protected Constraint constraint = null;
    public ArrayList<BitSet> result = null;
    public ArrayList<String> resultIds = null;
    public double timeOver = 1000.0 * 60 * 60;
    public PrintWriter Log = null;

    public void SetConstraint(Constraint con) {
        this.constraint = con;
    }

    public void SetExecuteTime(double time) {
        this.timeOver = time;
    }

    public void SetLogger(PrintWriter log) {
        this.Log = log;
    }

    public void PrintResultSize() {
        if (this.result != null) {
            System.out.print(this.result.size());
        } else {
            System.out.print("Nothing");
        }
    }

    protected Boolean InitializeCheck() {
        if (this.constraint == null) {
            System.out.println("not available constraints");
            return false;
        }

        return true;
    }

    public void IDGen() {
        if (this.result == null) {
            System.out.println("result is nothing");
        } else {
            ArrayList<Item> ItemBank = this.constraint.getItemBank();
            this.resultIds = new ArrayList<>();
            Iterator<BitSet> i = this.result.iterator();
            while (i.hasNext()) {
                BitSet tmp = i.next();
                String Stmp = new String("");

                int index = tmp.nextSetBit(0);
                boolean f = false;

                while (index >= 0) {
                    if (f) {
                        Stmp = Stmp + ",";
                    }
                    Stmp = Stmp + ItemBank.get(index).id;
                    index = tmp.nextSetBit(index + 1);
                    f = true;
                }
                this.resultIds.add(Stmp);
            }

        }
    }

    public void Generate() {

    }

    public void OutputResult(String FileName) {

        //todo:テスト条件毎にフォルダ構成を分けたい。

        String FileFullPath = this.OUTPUT_FILE_PATH + UtiltyFunction.GetFileName() + method + "_" + FileName;
        PrintWriter pt = null;
        try {
            pt = new PrintWriter(FileFullPath);
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }
        pt.println("版構成条件概要");
        pt.println("アイテムバンクサイズ," + this.constraint.getItemBank().size());

        pt.println("分野,出題数,重複項目数");
        for (int i = 0; i < this.constraint.Fields.size(); i++) {
            pt.println(this.constraint.Fields.get(i) + "," + this.constraint.NumOfItems.get(i) + "," + this.constraint.UBofOverlappingItems.get(i));
        }
        pt.println("theta,LB of I(theta), UB of I(theta)");
        for (int iii = 0; iii < this.constraint.theta.size(); iii++) {
            pt.print(this.constraint.theta.get(iii) + ",");
            pt.print(this.constraint.InformationUB.get(iii) + ",");
            pt.println(this.constraint.InformationLB.get(iii));
        }


        ExposureCounter e = new ExposureCounter();
        e.SetData(this.constraint.getItemBank());
        pt.println("構成テスト数," + this.result.size());
        pt.println("露出度," + e.Score(this.result));

        pt.println("以下構成テスト");
        pt.println("-----");
        IDGen();
        for (int i = 0; i < this.result.size(); i++) {
            //System.out.println(this.result.get(i));
            pt.println(this.resultIds.get(i));
        }
        pt.println("-----");

        pt.close();

    }
}
