package logic;

import java.util.BitSet;
import java.util.TreeSet;

import util.graph.GraphStructure;

public class MaxClique implements Runnable {


    public TreeSet<Integer> Qmax;
    private GraphStructure G;
    boolean debag = false;
    public volatile int max = 0;

    public volatile boolean isStop = false;
    private volatile long start;
    private volatile double TimeOver;

    public String Solve(GraphStructure g, double to) {

        start = System.currentTimeMillis();
        TimeOver = to;

        TreeSet<Integer> Q = new TreeSet();
        Qmax = new TreeSet();
        BitSet[] Adj = g.GetAdjMatrix();
        int l = Adj.length;
        BitSet V = new BitSet(l);

        V.flip(0, l - 1);
        EXPAND(V, Q, Adj);
        if (isStop) {
            return "TimeOver";
        } else {
            return "Optimal";
        }
    }


    private void EXPAND(BitSet SUBG, TreeSet<Integer> Q, BitSet[] Adj) {
        this.isStop = (this.TimeOver < System.currentTimeMillis() - start);

        if (isStop) {
            if (Q.size() > max) {
                Qmax = (TreeSet<Integer>) Q.clone();
                max = Qmax.size();
            }
            return;
        }
        if (SUBG.isEmpty()) {
            if (Q.size() > max) {
                Qmax = (TreeSet<Integer>) Q.clone();
                max = Qmax.size();
            }
            return;
        } else {

            Integer u = SUBG.nextSetBit(0);
            int dmax = Adj[u].cardinality();

            int i0 = SUBG.nextSetBit(0);
            while (i0 >= 0) {

                if (dmax < Adj[i0].cardinality()) {
                    u = i0;
                    dmax = Adj[u].cardinality();
                }
                i0 = SUBG.nextSetBit(i0 + 1);
            }


            Q.add(u);
            BitSet SUBGu = (BitSet) SUBG.clone();

            SUBGu.and(Adj[u]);


            if (Q.size() + SUBGu.cardinality() >= max) {
                EXPAND(SUBGu, Q, Adj);
            }
            Q.remove(u);


            BitSet EXTu = (BitSet) SUBG.clone();


            EXTu.clear(u);

            EXTu.andNot(SUBGu);

            for (int i = EXTu.cardinality(); i >= 2; i--) {


                Integer vi = -1;
                Integer djmax = -1;

                int i1 = EXTu.nextSetBit(0);
                while (i1 >= 0) {
                    BitSet tmp = (BitSet) Adj[i1].clone();
                    tmp.and(SUBG);
                    if (djmax < tmp.cardinality()) {
                        vi = i1;
                        djmax = tmp.cardinality();
                    }


                    i1 = EXTu.nextSetBit(i1 + 1);
                }


                BitSet Ui = (BitSet) Adj[vi].clone();
                Ui.and(EXTu);

                BitSet SUBGvi = (BitSet) Adj[vi].clone();
                SUBGvi.and(SUBGu);
                SUBGvi.or(Ui);

                if (Q.size() + SUBGvi.cardinality() + 1 >= max) {
                    Q.add(vi);

                    EXPAND(SUBGvi, Q, Adj);
                    Q.remove(vi);
                    EXTu.clear(vi);
                } else {
                    i = 1;
                }

            }

        }
    }

    @Override
    public void run() {
        do {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        } while (TimeOver > System.currentTimeMillis() - start);
        isStop = true;
    }


}
