package util;

import java.util.ArrayList;

public class Reader {
    public static boolean debug = false;

    public static ArrayList<Item> itemDBRead(String ItemDBPath) {
        ArrayList<Item> itemDB = new ArrayList<>();
        String[][] data = FileOpen.loadDataString(ItemDBPath);
        for (int i = 0; i < data.length; i++) {
            Item item = new Item();
            item.id = data[i][0];
            item.field = data[i][1];
            item.a = Double.parseDouble(data[i][2]);
            item.b = Double.parseDouble(data[i][3]);
            itemDB.add(item);
        }

        if (debug) {
            System.out.println("ItemDB.size():" + itemDB.size() + " items loaded");
        }

        return itemDB;
    }


    public static Constraint ConstraintRead(String ConstraintPath) {
        String[][] data = FileOpen.loadDataString(ConstraintPath);

        Constraint r = new Constraint();

        int i = 0;
        if (data[i][0].equals("time LB/UB")) {
            r.TimeLB = Double.parseDouble(data[i][1]);
            r.TimeUB = Double.parseDouble(data[i][2]);
            i++;
        }
        if (data[i][0].equals("theta")) {
            r.theta = new ArrayList<Double>();
            r.InformationLB = new ArrayList<Double>();
            r.InformationUB = new ArrayList<Double>();
            i++;
            while (!data[i][0].equals("fieldID")) {
                r.theta.add(Double.parseDouble(data[i][0]));
                r.InformationLB.add(Double.parseDouble(data[i][2]));
                r.InformationUB.add(Double.parseDouble(data[i][1]));
                i++;
            }
        }

        if (data[i][0].equals("fieldID")) {
            r.Fields = new ArrayList<String>();
            r.NumOfItems = new ArrayList<Integer>();
            r.UBofOverlappingItems = new ArrayList<Integer>();
            i++;
            while (i < data.length) {
                r.Fields.add(data[i][0]);
                r.NumOfItems.add(Integer.parseInt(data[i][1]));
                r.UBofOverlappingItems.add(Integer.parseInt(data[i][2]));
                i++;
            }
        }

        return r;
    }

    public static Constraint ConstraintRead(int c, int[] NoGroupItem, int[] NoOverlapItem, double[][][] ConInfo) {
        Constraint r = new Constraint();
        int n_NoGroupItem = 0;
        int n_NoOverlapItem = 0;
        int n_ConInfo = 0;

        int init = 0;
        for (int i = 0; i < NoGroupItem.length; i++) {
            for (int j = 0; j < NoOverlapItem.length; j++) {
                for (int k = 0; k < ConInfo.length; k++) {
                    if (c == init) {
                        n_NoGroupItem = i;
                        n_NoOverlapItem = j;
                        n_ConInfo = k;
                        init = -1;
                    } else {
                        init++;
                    }
                    if (init == -1) break;
                }
                if (init == -1) break;
            }
            if (init == -1) break;
        }
        r.TimeLB = 0.0;
        r.TimeUB = 9999.0;

        r.theta = new ArrayList<Double>();
        r.InformationLB = new ArrayList<Double>();
        r.InformationUB = new ArrayList<Double>();
        for (int i = 0; i < ConInfo[n_ConInfo].length; i++) {
            r.theta.add(ConInfo[n_ConInfo][i][0]);
            r.InformationLB.add(ConInfo[n_ConInfo][i][2]);
            r.InformationUB.add(ConInfo[n_ConInfo][i][1]);
        }

        r.Fields = new ArrayList<String>();
        r.NumOfItems = new ArrayList<Integer>();
        r.UBofOverlappingItems = new ArrayList<Integer>();
        r.Fields.add("A");
        r.NumOfItems.add(NoGroupItem[n_NoGroupItem]);
        r.UBofOverlappingItems.add(NoOverlapItem[n_NoOverlapItem]);

        //System.out.println(r);

        return r;
    }

    public static int getNoGroupItem(int c, int[] NoGroupItem, int[] NoOverlapItem, double[][][] ConInfo) {
        int n_NoGroupItem = 0;
        int n_NoOverlapItem = 0;
        int n_ConInfo = 0;
        String name;

        int init = 0;
        for (int i = 0; i < NoGroupItem.length; i++) {
            for (int j = 0; j < NoOverlapItem.length; j++) {
                for (int k = 0; k < ConInfo.length; k++) {
                    if (c == init) {
                        n_NoGroupItem = i;
                        n_NoOverlapItem = j;
                        n_ConInfo = k;
                        init = -1;
                    } else {
                        init++;
                    }
                    if (init == -1) break;
                }
                if (init == -1) break;
            }
            if (init == -1) break;
        }

        return n_NoGroupItem;
    }

    public static String getConstraintName(int c, int[] NoGroupItem, int[] NoOverlapItem, double[][][] ConInfo) {
        int n_NoGroupItem = 0;
        int n_NoOverlapItem = 0;
        int n_ConInfo = 0;
        String name;

        int init = 0;
        for (int i = 0; i < NoGroupItem.length; i++) {
            for (int j = 0; j < NoOverlapItem.length; j++) {
                for (int k = 0; k < ConInfo.length; k++) {
                    if (c == init) {
                        n_NoGroupItem = i;
                        n_NoOverlapItem = j;
                        n_ConInfo = k;
                        init = -1;
                    } else {
                        init++;
                    }
                    if (init == -1) break;
                }
                if (init == -1) break;
            }
            if (init == -1) break;
        }

        name = "NoGroupItem" + NoGroupItem[n_NoGroupItem] + "_NoOverlapItem" + NoOverlapItem[n_NoOverlapItem] + "_ConInfo" + n_ConInfo;
        return name;
    }

    public static void main(String[] args) {
        int[] NoGroupItem = {10, 20, 30, 40, 50, 100, 200};
        int[] NoOverlapItem = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
        double[][][] ConInfo = {
                {{-2, 9.6 * 0.5, 8 * 0.5}, {-1, 14.4 * 0.5, 12.8 * 0.5}, {0, 14.4 * 0.5, 12.8 * 0.5}, {1, 14.4 * 0.5, 12.8 * 0.5}, {2, 9.6 * 0.5, 8 * 0.5}},
                {{-2, 9.6, 8}, {-1, 14.4, 12.8}, {0, 14.4, 12.8}, {1, 14.4, 12.8}, {2, 9.6, 8}},
                {{-2, 9.6 * 2, 8 * 2}, {-1, 14.4 * 2, 12.8 * 2}, {0, 14.4 * 2, 12.8 * 2}, {1, 14.4 * 2, 12.8 * 2}, {2, 9.6 * 2, 8 * 2}}
        };
        Constraint con = Reader.ConstraintRead(50, NoGroupItem, NoOverlapItem, ConInfo);
        con.print();
        System.out.print(Reader.getConstraintName(50, NoGroupItem, NoOverlapItem, ConInfo));
    }
}
