package util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Random;

import lib.MTRandom;

public class SimulationItemGenerator {

    private static String PATH = ".//";
    public static String ITEMDBPATH = PATH + "ItemDB//sample1000.csv";
    public static int num = 1000;
    public static String[] field;
    public static DecimalFormat df = new DecimalFormat("0000");

    public Random rnd = null;

    public SimulationItemGenerator(long seed) {
        rnd = new MTRandom(seed);
    }

    public SimulationItemGenerator() {
        rnd = new MTRandom();
    }

    public Item GenerateItem() {
        double a = rnd.nextGaussian();
        a = Math.pow(2, a);
        double b = rnd.nextGaussian();
        return new Item(a, b);
    }

    public void generate() {
        File file = new File(ITEMDBPATH);
        try {
            PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(file)));

            for (int i = 0; i < field.length; i++) {
                for (int j = 0; j < num / field.length; j++) {
                    String data = "";

                    Item tmp = this.GenerateItem();
                    tmp.id = field[i] + "_" + this.df.format(j + 1);
                    tmp.field = field[i];

                    data += tmp.id;
                    data += ",";
                    data += tmp.field;
                    data += ",";
                    data += tmp.a;
                    data += ",";
                    data += tmp.b;

                    pw.println(data);
                }
            }
            pw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        SimulationItemGenerator gene = new SimulationItemGenerator();
        gene.generate();
    }
}
